#ifndef _BIOS_HH_
#define _BIOS_HH_
#include <string>
#include <sys/types.h>
#include <hwlist.hh>


#define BIOS_ROM_START  0xc0000
#define BIOS_ROM_SIZE   0x40000

#define BIOS_RAM_START  0x400
#define BIOS_RAM_SIZE   0x100

#define SMBIOS_SIGNATRUE 0x5f4d535f

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

struct dmi_header
{
  u8 type;
  u8 length;
  u16 handle;
};


namespace libhw
{
  class bios
  {
  public:
    struct hw_sys
    {
      std::string version;
      std::string vendor;
      std::string product;
      std::string serial;
    };
    struct hw_sys hws;

    bios(hwlist & );

    void dmi_table(hwlist & hwlist, 
		   int fd,
		   u32 base,
		   int len,
		   int num,
		   int dmiversionmaj,
		   int dmiversionmin);
  private:
    std::string dmi_chassis_type(u8 code);

    std::string dmi_string(struct dmi_header *dm, u8 s);
    std::string dmi_handle(u16 handle);
    struct sm_info
    {
      unsigned hlen;
      unsigned addr;
      unsigned len;
      unsigned structs;
    };
    struct sm_info info;
  };
}

#endif

