#ifndef _HWDB_HH_
#define _HWDB_HH_

#include <vector>
#include <set>
#include <string>
#include <hwlist.hh>

namespace libhw
{
  class hwdb: public hwlist
  {
  public:
    std::string current;
    std::vector<std::string> dbformat;
    hwdb(const std::string& file, std::vector<std::string> format );
    hwdb(const std::string& file, std::vector<std::string> format, std::vector<std::string> loadonly );
    hwdb(void);

    void init(const std::string& file,std::vector<std::string> format, std::vector<std::string> loadonly);
   
    void exec_cond(std::string path);
  private:
    void load();
    bool in_filter(const std::string & line);
    bool loadfile(const char* & file, std::vector < std::string > & list);
    void parse(const std::string & line);
    void add(const std::string & line);
    void add_parameter(const std::string line);
    void add_condition(const std::string line);
    
    std::string dbfile;
    unsigned int linenumber;
    std::vector<std::string> filter;
  };
}

#endif
