#ifndef _STORAGE_HH_
#define _STORAGE_HH_

#include <vector>
#include <string>
#include <hwdb.hh>

namespace libhw
{
#define SYS_BLOCK "/sys/block"
#define SYS_BUS_SCSI "/sys/bus/scsi/devices"
#define PROC_IDE "/proc/ide"
  struct ata_cmd {
    unsigned char cmd;
    unsigned char sector_number;
    unsigned char feature;
    unsigned char sector_count;
    unsigned char buf[512];
  };
  class storage {
    hwdb classdb;
    hwdb fstypedb;
  public:
    storage(hwdb & hwlist);
  private:
    void read_sysfs_context(const char* sysdir,hwdb & hwlist);
    std::string read_size(std::string path);
    std::string storage_type(char *dev, char *bus, hwlist &hwlist);
    void read_scsi_info(std::string devpath, hwlist &hwlist);
    void read_ide_info(std::string devpath, hwlist &hwlist);
    void get_partitions(std::string devpath, hwlist &hwlist, char* device);
  };
}

#endif

