#ifndef VIDEO_HH__
#define VIDEO_HH__

#include <list>

#include <hwdb.hh>


namespace hwdatabase
{
	/** generic blackbox for configurator */
	class video_cards
	{
			template <typename ExtActor>
			struct converter
			{
				converter(ExtActor a):
					a_(a)
				{}
				void operator() (std::string name, libhw::pot::attrs_t attr) 
				{
					a_(name.substr(1,name.length()-2));
				}
				ExtActor a_;
			};
		public:
			typedef std::pair<std::string,std::string> option_type;
			typedef std::list<option_type> option_list_type;
		
			video_cards(const std::string& dbpath);
			template <typename Actor>
			void for_each_card(Actor a)
			{
				db_["/"].for_each_branch(converter<Actor>(a));
			}
			
			void options(const std::string &cardname,option_list_type& options);
		private:
			libhw::hwdb db_;
	};
}

#endif
